package com.jz.dmp.config;

import java.util.List;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.connection.RedisClusterConfiguration;
import org.springframework.data.redis.connection.RedisNode;
import org.springframework.data.redis.connection.jedis.JedisConnectionFactory;
import org.springframework.session.data.redis.config.annotation.web.http.EnableRedisHttpSession;

@Configuration
@EnableRedisHttpSession
@ConfigurationProperties(prefix = "spring.redis.cluster")
public class SessionConfig {
	
    private List<String> nodes;

    @Bean
    public JedisConnectionFactory connectionFactory() {
        
        RedisClusterConfiguration redisClusterConfiguration = new RedisClusterConfiguration();
        
        nodes.stream().forEach(node->{
        	String[] strs = node.split(":");
        	String host = strs[0];
        	int port = Integer.parseInt(strs[1]);
        	RedisNode redisNode = new RedisNode(host, port);
        	redisClusterConfiguration.addClusterNode(redisNode);
        });

        return new JedisConnectionFactory(redisClusterConfiguration);
    }

	public List<String> getNodes() {
		return nodes;
	}

	public void setNodes(List<String> nodes) {
		this.nodes = nodes;
	}

}
